From 00733fac960526e25e5f7e5d68be48d042d28315 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Mattias=20Engdeg=C3=A5rd?= <mattiase@acm.org>
Date: Tue, 16 Apr 2019 15:13:57 +0200
Subject: [PATCH] * autorevert.el (auto-revert-notify-rm-watch): Simplify.

---
 lisp/autorevert.el | 24 +++++++++++-------------
 1 file changed, 11 insertions(+), 13 deletions(-)

diff --git a/lisp/autorevert.el b/lisp/autorevert.el
index 1dc2f0eafd..cf9dc53f85 100644
--- a/lisp/autorevert.el
+++ b/lisp/autorevert.el
@@ -501,19 +501,17 @@ will use an up-to-date value of `auto-revert-interval'"
   "Disable file notification for current buffer's associated file.
 If REMOVE-DESCRIPTOR is non-nil, remove the corresponding notification
 descriptor; otherwise assume that it has already been removed."
-  (when auto-revert-notify-watch-descriptor
-    (maphash
-     (lambda (key value)
-       (when (equal key auto-revert-notify-watch-descriptor)
-	 (setq value (delete (current-buffer) value))
-	 (if value
-	     (puthash key value auto-revert-notify-watch-descriptor-hash-list)
-	   (remhash key auto-revert-notify-watch-descriptor-hash-list)
-           (when remove-descriptor
-	     (ignore-errors
-	       (file-notify-rm-watch auto-revert-notify-watch-descriptor))))))
-     auto-revert-notify-watch-descriptor-hash-list)
-    (remove-hook 'kill-buffer-hook #'auto-revert-notify-rm-watch-callback t))
+  (let ((desc auto-revert-notify-watch-descriptor)
+        (table auto-revert-notify-watch-descriptor-hash-list))
+    (when desc
+      (let ((buffers (delq (current-buffer) (gethash desc table))))
+        (if buffers
+            (puthash desc buffers table)
+          (remhash desc table)))
+      (when remove-descriptor
+	(ignore-errors
+	  (file-notify-rm-watch desc)))
+      (remove-hook 'kill-buffer-hook #'auto-revert-notify-rm-watch-callback t)))
   (setq auto-revert-notify-watch-descriptor nil
 	auto-revert-notify-modified-p nil))
 
-- 
2.20.1 (Apple Git-117)

